<?php
	/**
	* 
	*/
	function gnms_selector( $groupName, $postID, $group, $fields)
	{
		
		?>

		
		<script type="text/javascript">
		//<![CDATA[
			var postID = <?php echo $postID; ?>;
			jQuery(document).ready(function($) {
					$('div.gnms').gnMediaSelector();
			});		
		//]]>
		</script>
		
		<div id="<?php echo $groupName; ?>" class="gnms">
			<div class="gnms-header">
			<?php if(isset($group['title']) && $group['title'] != ''):?><h2><?php echo $group['title']; ?></h2><?php endif; ?>
			<?php if(isset($group['description']) && $group['description'] != ''):?><p><?php echo $group['description']; ?></p><?php endif; ?>
			</div>
		</div>	
		<noscript>
			<div class="error"><p>Sorry but the "Media Selector" plugin currently requires you to have Javascript enabled</p></div>
		</noscript>			
		<?php
	}


	/**
	* Creates the base page for popup image selection
	*/
	function gnms_iframe($content_func /* ... */) {
		global $gnms;
	?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
	<head>
	<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
	<title><?php bloginfo('name') ?> &rsaquo; <?php _e('Uploads'); ?> &#8212; <?php _e('WordPress'); ?></title>
	<?php
	wp_enqueue_style( 'global' );
	wp_enqueue_style( 'wp-admin' );
	wp_enqueue_style( 'colors' );
	wp_enqueue_style( 'media' );
	wp_enqueue_style( 'ie' );
	?>
	<script type="text/javascript">
	//<![CDATA[
	addLoadEvent = function(func){if(typeof jQuery!="undefined")jQuery(document).ready(func);else if(typeof wpOnload!='function'){wpOnload=func;}else{var oldonload=wpOnload;wpOnload=function(){oldonload();func();}}};
	var userSettings = {'url':'<?php echo SITECOOKIEPATH; ?>','uid':'<?php if ( ! isset($current_user) ) $current_user = wp_get_current_user(); echo $current_user->ID; ?>','time':'<?php echo time(); ?>'};
	var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>', pagenow = 'media-upload-popup', adminpage = 'media-upload-popup';
	var pluginpath = '<?php echo WP_PLUGIN_URL; ?>';
	//]]>
	</script>
	<?php
	//do_action('admin_enqueue_scripts', 'media-upload-popup');
	//do_action('admin_print_styles-media-upload-popup');
	do_action('admin_print_styles');
	//do_action('admin_print_scripts-media-upload-popup');
	do_action('admin_print_scripts');
	//do_action('admin_head-media-upload-popup');
	//do_action('admin_head');
	?>
	</head>
	<body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?>>
	<?php
		$args = func_get_args();
		$args = array_slice($args, 1);
		call_user_func_array($content_func, $args);
	?>
	</body>
	</html>
	<?php
	}

	/**
	* 
	*/
	function gnms_choose()
	{
		global $gnms;
		
		$base_url 	= '?groupName='.$_GET['groupName'].'&#038;postID='.$_GET['postID'].'&#038;elementIndex='.$_GET['elementIndex'];
		$select_url = $base_url.'&#038;action=choose';
		$crop_url 	= $base_url.'&#038;action=crop';
		
		
		$groupName = isset($_GET['groupName']) ? $_GET['groupName'] : NULL;
		$groupFieldIndex = isset($_GET['groupFieldIndex']) ? intval($_GET['groupFieldIndex']) : NULL;
		
		if(isset($_GET['asset_id']))
		{
			$select_url .= '&#038;asset_id='.$_GET['asset_id'];
			$crop_url .= '&#038;asset_id='.$_GET['asset_id'];
		}
		
		if(isset($_GET['ID']))
		{
			$base_url .= '&#038;ID='.$_GET['ID'];
			$select_url .= '&#038;ID='.$_GET['ID'];
			$crop_url .= '&#038;ID='.$_GET['ID'];	
		}
		
		if(isset($_GET['groupFieldIndex']))
		{
			$base_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
			$select_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
			$crop_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
		}
		
		$post_attachments = $gnms->getAttachments( $groupName, $groupFieldIndex, TRUE );
		$attachments = $gnms->getAttachments( $groupName, $groupFieldIndex );
		$fileTypes = $gnms->getFileTypes( $groupName, $groupFieldIndex );
	?>
	<div id="wphead">
		<ul id="gnms-crumb">
			<li class="current"><a href="<?php echo WP_PLUGIN_URL . '/gn-media-selector/gnms_actions.php'.$select_url; ?>"><span>Select</span></a></li>
			<?php if(isset($_GET['asset_id'])):?>
			<li><a href="<?php echo WP_PLUGIN_URL . '/gn-media-selector/gnms_actions.php'.$crop_url; ?>"><span>Edit</span></a></li>
			<?php else: ?>
			<li><span>Edit</span></li>
			<?php endif; ?>
		</ul>
	</div>
	<div id="gnms-notice">
		<p><?php _e( 'To have an image selectable here you will need to upload it in media section', 'Gnms' ); ?></p>
	</div>
	<? if(count($attachments) == 0): ?>
	<div class="error">
		<p><?php _e( 'Either there are no media assets or no files with the correct file extension have been uploaded to the media library, the correct file extensions are:', 'Gnms' ); ?></p>
		<ul>
			<?php foreach($fileTypes as $type): ?>
			<li>.<?php echo $type; ?></li>
			<?php endforeach; ?>
		</ul>
	</div>
	<?php endif; ?>
	<div id="gnms-wrapper">

	<h3>Attached Assets</h3>
	<ul id="gnms-post-attachments" class="gnms-attachments">
		<?php
			//
			if(count($post_attachments) == 0){
			?>
			<p><?php _e('No attachments for this post','Gnms'); ?><p>
			<?php	
			}else{
				foreach($post_attachments as $asset){	
		?>
		<li><a href="gnms_actions.php<?php echo $base_url.'&#038;action=crop&#038;srcID='.$asset->ID; ?>"><?php echo wp_get_attachment_image( $asset->ID, 'selector-thumbnail', true ); ?></a></li>
		<?php 	
				}
			};
		?>
	</ul>
	<div class="clear"></div>
	<h3>General Assets</h3>
	<ul id="gnms-attachments" class="gnms-attachments">
		<?php
			
			if(count($attachments) == 0){
			?>
			<p><?php _e('No media for selection','Gnms'); ?><p>
			<?php	
			}else{
				foreach($attachments as $asset){
		?>
		<li><a href="gnms_actions.php<?php echo $base_url.'&#038;action=crop&#038;srcID='.$asset->ID; ?>"><?php echo wp_get_attachment_image( $asset->ID, 'selector-thumbnail', true ); ?></a></li>
		<?php 
				};
			}; 
		?>
	</ul>
	<div class="clear"></div>
	</div>
	<script>
	jQuery(document).ready(function($) {
		$("img[title]").tooltip({ effect: 'slide'}).dynamic({ bottom: { direction: 'down', bounce: true } });
	});
	</script>
	<!-- tooltip styling -->
	<style>

	/* tooltip styling. by default the element to be styled is .tooltip  */
	.tooltip {
		background-color:#000000;
		font-size:12px;
		height:20px;
		padding:10px;
		color:#fff;	
		
		display:block;
		-moz-box-shadow: rgba(200,200,200,1) 0 4px 18px;
		-webkit-box-shadow: rgba(200,200,200,1) 0 4px 18px;
		-khtml-box-shadow: rgba(200,200,200,1) 0 4px 18px;
		box-shadow: rgba(200,200,200,1) 0 4px 18px;
		
		-moz-border-radius: 8px;
		-khtml-border-radius: 8px;
		-webkit-border-radius: 8px;
		border-radius: 4px;
	}
	</style>
	<!-- use gif image for IE -->
	<!--[if lt IE 7]>
	<style>
	.tooltip {
		background-image:url(/tools/img/tooltip/black_arrow.gif);
	}
	</style>
	<![endif]-->
	
	<?php 
	};


	/**
	* 
	*/
	function gnms_crop()
	{
		$base_url 	= '?groupName='.$_GET['groupName'].'&#038;postID='.$_GET['postID'].'&#038;elementIndex='.$_GET['elementIndex'];
		$select_url = $base_url.'&#038;action=choose';
		$crop_url 	= $base_url.'&#038;action=crop';
		
		if(isset($_GET['asset_id']))
		{
			$select_url .= '&#038;asset_id='.$_GET['asset_id'];
			$crop_url .= '&#038;asset_id='.$_GET['asset_id'];
		}
		if(isset($_GET['ID']))
		{
			$select_url .= '&#038;ID='.$_GET['ID'];
			$crop_url .= '&#038;ID='.$_GET['ID'];	
		}
		if(isset($_GET['groupFieldIndex']))
		{
			$base_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
			$select_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
			$crop_url .= '&#038;groupFieldIndex='.$_GET['groupFieldIndex'];
		}
	?>
	<script type="text/javascript">
	//<![CDATA[	
	var ID = <?php echo (isset( $_GET['ID'])) ? $_GET['ID'] : 'null'; ?>;
	var groupName = '<?php echo $_GET['groupName']; ?>';
	var srcID =  <?php echo $_GET['srcID']; ?>;
	var postID =  <?php echo $_GET['postID']; ?>;
	var groupFieldIndex = <?php echo (isset( $_GET['groupFieldIndex'])) ? $_GET['groupFieldIndex'] : -1; ?>;
	var elementIndex =  <?php echo $_GET['elementIndex']; ?>;
	var crop_screen = true;
	
	//]]>
	</script>
	
	<div id="wphead">
		<ul id="gnms-crumb">
			<li><a href="<?php echo WP_PLUGIN_URL . '/gn-media-selector/gnms_actions.php'.$select_url; ?>"><span>Select</span></a></li>
			<li class="current"><a href="<?php echo WP_PLUGIN_URL . '/gn-media-selector/gnms_actions.php'.$crop_url; ?>"><span>Edit</span></a></li>
		</ul>
	</div>

	<div id="gnms-notice">
		<p><?php _e( 'Crop image if needed', 'Gnms' ); ?></p>
	</div>
	<div id="gnms-wrapper">
		<div id="gnms-source-image-area">
			<div class="gnms-source-image-loading"><?php _e( 'Loading', 'Gnms' ); ?> ...</div>
		</div>
		<!--
		<form onsubmit="return false;" style="float:right;">
			<label>X1 <input type="text" size="4" id="x" name="x" /></label>
			<label>Y1 <input type="text" size="4" id="y" name="y" /></label>
			<label>X2 <input type="text" size="4" id="x2" name="x2" /></label>
			<label>Y2 <input type="text" size="4" id="y2" name="y2" /></label>
			<label>W <input type="text" size="4" id="w" name="w" /></label>
			<label>H <input type="text" size="4" id="h" name="h" /></label>
		</form>
		-->
	</div>
	<div id="gnms-media-crop-text">
		<label for="gnms-media-title"><?php _e('Title','Gnms'); ?></label>
		<input type="text" name="gnms-media-title" value="" id="gnms-media-title" />
		<label for="gnms-media-alt"><?php _e('Alt title', 'Gnms'); ?></label>
		<input type="text" name="gnms-media-alt" value="" id="gnms-media-alt" />
		<label for="gnms-media-caption"><?php _e('Caption', 'Gnms'); ?></label>
		<input type="text" name="gnms-media-caption" value="" id="gnms-media-caption" />
		<label for="gnms-media-description"><?php _e('Description', 'Gnms'); ?></label>
		<textarea rows="4" cols="40" type="text" name="gnms-media-description" value="" id="gnms-media-description"></textarea>
	</div>
	<div id="gnms-crop-button">
		<input type="button" id="gnms_save_button" class="button" value="<?php _e( 'Save Changes', 'Gnms' ); ?>"/>
	</div>
	<?php
	}
?>