jQuery(document).ready(function($) {

    var debug = true;
    log = function(args) {
        if (debug && window.console && window.console.log) {
            window.console.log.apply(window.console, arguments);
        }
    }

    if (typeof(pluginpath) != "undefined")
    {
        var pluginpath = '../wp-content/plugins/wp-post-thumbnail';
    }

    var isImage,
	thumbWidth,
    thumbHeight,
    srcWidth,
    srcHeight,
    scaleRatio,
    jcrop_api;
    var x = 0,
    y = 0,
    x2 = 0,
    y2 = 0,
    w = 0,
    h = 0;

    $.ajaxSetup({
        type: 'POST',
        url: ajaxurl,
        cache: false,
        timeout: (30 * 1000)
    });

    function loadScreenData()
    {
        $.ajax({
            data: {
                action: 'getSrcAttachment',
                'cookie': encodeURIComponent(document.cookie),
                'groupName': groupName,
                'ID': ID,
                'srcID': srcID,
                'postID': postID,
                'groupName': groupName,
                'groupFieldIndex': groupFieldIndex,
                'elementIndex': elementIndex,
                'containerWidth': 645,
                'containerHeight': 400
            },
            dataType: 'json',
            success: function(response) {
				isImage = false;
				setDisplay(response);
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                alert(textStatus + " : " + errorThrown);
                $("#wppt-source-image-area > .wppt-source-image-loading").hide();
            },
            complete: function() {}
        });

    }


    //
    if (typeof(crop_screen) != "undefined")
    {
        loadScreenData();
    }
	
	
    function setDisplay(data) {

        /* Image attachment source is not found */
        if (typeof(data['error']) != "undefined") {
            /* Remove current source image and divs. Hide source image loading message. */
            $("#gnms-source-image-area > .gnms-source-image-loading").hide();
            /* Hide loading message */

            if (data['assetID'] == $('#gnms-source-image').data('id')) {
                $("#gnms-source-image-area").hide().
                children('img, div').not(".gnms-source-image-loading").remove();
            }

            alert(data['error']);
            return false;
        }
		
		if(data.isImage)
		{
			/* Load the source image for cropping */
			isImage = true;
	        srcWidth = data[1];
	        srcHeight = data[2];
	        thumbWidth = data['thumbWidth'];
	        thumbHeight = data['thumbHeight'];
	        scaleRatio = data['scaleRatio'];
		}
		
		log(data['imageSrc']);

        var img = new Image();

        $(img).attr({
            id: "gnms-source-image",
            src: data['imageSrc']
        })
        .data("abspathToSrc", data['abspath']).data("id", data['srcID'])
        .load(function() {

            /* Remove current source image and divs */
            $("#gnms-source-image-area").children('img, div').not(".gnms-source-image-loading").remove();
            $("#gnms-source-image-area").prepend(this);

			/* Prepend new source image */
            $("#gnms-source-image-area > .gnms-source-image-loading").hide();
            /* Hide loading message */
			
			if(isImage)
			{
				if ((thumbWidth >= srcWidth) || (thumbHeight >= srcHeight)) {
	                alert(data['warning_smallSrcImg']);
	            }

	            if (jcrop_api != null) {
	                jcrop_api.destroy();
	            }

	            jcrop_api = $.Jcrop(this);

	            jcrop_api.setOptions({
	                trueSize: [srcWidth, srcHeight],
	                allowSelect: false,
	                onChange: showCoords
	            });

	            if (thumbWidth != null || thumbHeight != null)
	            {
	                jcrop_api.setOptions({
	                    allowSelect: false
	                });
	                jcrop_api.setOptions(((thumbWidth >= srcWidth) || (thumbHeight >= srcHeight)) ? {
	                    minSize: [0, 0]
	                }: {
	                    minSize: [thumbWidth, thumbHeight]
	                });
	                jcrop_api.setOptions({
	                    aspectRatio: thumbWidth / thumbHeight
	                });
	                jcrop_api.setSelect((typeof(data['x']) != "undefined") ? [data['x'], data['y'], data['x'] + data['w'], data['y'] + data['h']] : [0, 0, thumbWidth, thumbHeight]);
	            } else {

	                if ((typeof(data['x']) != "undefined"))
	                jcrop_api.setSelect([data['x'], data['y'], data['x'] + data['w'], data['y'] + data['h']]);
	                else
	                jcrop_api.setOptions({
	                    allowSelect: true
	                });

	            }
	            jcrop_api.focus();
			}else{
				
			}

        });
        /* $(img) chaining */

        $('#gnms-media-title').val((data['title']) ? data['title'] : '');
        $('#gnms-media-alt').val((data['alt_title'])  ? data['alt_title'] : '');
	 	$('#gnms-media-caption').val((data['caption'])  ? data['caption'] : '');
	   	$('#gnms-media-description').val((data['description'])  ? data['description'] : '');
    }
    /* loadImageBindJcrop() */

    function showCoords(c)
    {
        jQuery('#x').val(c.x);
        jQuery('#y').val(c.y);
        jQuery('#x2').val(c.x2);
        jQuery('#y2').val(c.y2);
        jQuery('#w').val(c.w);
        jQuery('#h').val(c.h);

    }
    /* --------------------------------------------------------- "Crop Image" button click event ----- */


    $('#gnms_save_button').click(function(e) {
		
		var data = {
            action: 'saveFileReference',
            'cookie': encodeURIComponent(document.cookie),
            'ID': ID,
            'srcID': srcID,
            'groupName': groupName,
            'groupFieldIndex': groupFieldIndex,
            'postID': postID,
            'title': $('#gnms-media-title').val(),
            'altTitle': $('#gnms-media-alt').val(),
            'caption': $('#gnms-media-caption').val(),
            'description': $('#gnms-media-description').val()
        };
		
		if(isImage)
		{
			var coords = jcrop_api.tellSelect();
			
            data.action = 'saveCropppedImage';
			data.x = coords.x;
            data.y = coords.y;
            data.x2 = coords.x2;
            data.y2 = coords.y2;
            data.w = (coords.x2 - coords.x) / scaleRatio;
            data.h = (coords.y2 - coords.y) / scaleRatio;
            data.scaleRatio = scaleRatio;
		}
				
        //
        $('#gnms_save_button').fadeOut(228,
        function() {
            //$('#gnms_save_button_area_loading').show();
            });

        $.ajax({
            data: data,
            dataType: 'json',
            success: function(response)
            {
                var win = window.dialogArguments || opener || parent || top;

                if (response)
                {

                    log("Cropped Image and got a respnse");
                    log(response.ID);

                    $('#attachments_buttons').show();

                    // update window wp
                    win.GNMSUpdateMediaSelector(response.groupName, response.ID, elementIndex);
                    //
                } else {
                    alert('Sorry but there was an error cropping the Image');
                }
                win.tb_remove();
            }
        });
    });
});
